macroScript Legolizer category:"Piranha-Bytes"	buttonText:"Legolize" toolTip:"Legolizer v0.8"
(
	struct legoStruct  (BaseObject = undefined, Root = undefined, LegoSnap = undefined, legoOffset = [0,0,0], mres = undefined, blockSize = 1, maxBlocks = [1,1,1], bps = 5, mirror = 4, numMats = 1, matIDList = #(), prioList = #(), blockList = #(), buildingArray = #(), building_blocks = #(), baseBLockList = ())
	struct buildingBlock (obj, x = 1, y = 1, z = 1, bCount, bDistObj, bMeshObj)
	
	local legoObj = undefined
	local lastLego = undefined
	local distObj = undefined
	local legoPath = undefined
	local libraryPath = undefined
	local ro_Legolizer_BlockBuilder, ro_legolizer_Build
	
	function lg_resetXForm obj =
	(
		ntm = obj.transform
		obj.transform = transMatrix obj.pos
		piv = obj.objecttransform * inverse obj.transform
		obj.objectoffsetPos  = [0,0,0]
		obj.objectoffsetRot = (quat 0 0 0 1)
		obj.objectoffsetScale = [1,1,1]
		ntm.translation=[0,0,0]
		ntm = piv * ntm
		xformMod = xform()
		addmodifier obj xformMod
		xformMod.gizmo.transform=ntm
		collapseStack obj
	)
	
	function deleteLegoObj =
	(
		if legoObj != undefined do
		(
			if ((legoObj.legoSnap != undefined) and (legoObj.legoSnap.isDeleted == false)) then delete legoObj.legoSnap
			if ((legoObj.root != undefined) and (legoObj.root.isDeleted == false)) then delete legoObj.root
			legoObj = undefined
		)
	)

	
	rollout ro_Legolizer_BlockBuilder "Block Builder"
	(
		listbox ui_BB_CurrentBlockLibList "Block Library:" pos:[5,5] width:95 height:6 items:#()
		button ui_BB_Import "Import" pos:[5,110] width:48 height:20 tooltip:"Import Building Block"
		button ui_BB_Del "Delete" pos:[53,110] width:47 height:20 tooltip:"Delete selected Building Block"
		

		groupBox grp_BB_Edit "Edit Block" pos:[105,5] width:140 height:135
		
		editText ui_BB_BName "Name:" pos:[110,28] fieldwidth:90 text:"NewBlock"
		spinner ui_BB_SizeX "Size: " pos:[110,55] fieldwidth:25 scale:1 type:#integer range:[1,1,1] 
		spinner ui_BB_SizeY "X  " pos:[180,55] fieldwidth:25 scale:1 type:#integer range:[1,9999,1]

		button ui_BB_CreateDefault "Create Base Block" pos:[110,80] width:130 height:20 tooltip:"Create Base Mesh"
		button ui_BB_SaveBlock "Save" pos:[110,110] width:65 height:20 tooltip:"Save current Building Block"
		button ui_BB_ClearBlock "Clear" pos:[175,110] width:65 height:20 tooltip:"Clear current Building Block"

		local currentBuildingBlock = undefined

		function refreshBBList2 =
		(
			bbs = getFiles (libraryPath + "*.max")
			bbnames = #()
			for b=1 to bbs.count do
			(
				n = getFilenamefile bbs[b]
				append bbnames n
			)
			sort bbnames
			ui_BB_CurrentBlockLibList.items = bbnames
		)

		on ro_Legolizer_BlockBuilder open do refreshBBList2()
		on ro_Legolizer_BlockBuilder close do 
		(
			if ((currentBuildingBlock != undefined) and (currentBuildingBlock.isDeleted == false)) then delete currentBuildingBlock
			ro_legolizer_Build.refreshBBList()
		)
		on ui_BB_Del pressed do
		(
			ask = queryBox "Really delete this Building Block?"
			if ask == true do
			(
				name = ui_BB_CurrentBlockLibList.selected + ".max"
				deleteFile (libraryPath + name)
				refreshBBList2()
				ro_legolizer_Build.refreshBBList()
			)
		)

		on ui_BB_Import pressed do
		(
			if ui_BB_CurrentBlockLibList.selection != 0 do
			(
				if ((currentBuildingBlock != undefined) and (currentBuildingBlock.isDeleted == false)) then delete currentBuildingBlock

				sbName = ui_BB_CurrentBlockLibList.selected
				mergeMaxFile (libraryPath + sbName + ".max") #select #mergeDups
				currentBuildingBlock = (getCurrentSelection())[1]
				
				nameParts = filterString sbName "_"
				
				ui_BB_BName.text = nameParts[1]
				dims = filterString nameParts[2] "x"
				ui_BB_SizeX.value = dims[1] as integer
				ui_BB_SizeY.value = dims[2] as integer
			)
		)
		
		on ui_BB_CreateDefault pressed do
		(
			if ((currentBuildingBlock != undefined) and (currentBuildingBlock.isDeleted == false)) then delete currentBuildingBlock
			newBB = box pos:[0,0,0]
			
			newBB.height = 1
			newBB.Length = ui_BB_SizeX.value
			newBB.width = ui_BB_SizeY.value
			newBB.widthSegs = ui_BB_SizeY.value

			newBB.pivot = [0,0,0.5]
			newBB.pos = [(ui_BB_SizeY.value - 1) / 2.0,0,0]
			newBB.pivot = [0,0,0]
			newBB.Name = ui_BB_BName.text + "_" + ( ui_BB_SizeX.value as string) + "x" + ( ui_BB_SizeY.value as string)
				--lg_ResetXForm newBB	
			currentBuildingBlock = newBB
			select currentBuildingBlock
		)
		
		on ui_BB_BName entered newName do
		(
			if ((currentBuildingBlock != undefined) and (currentBuildingBlock.isDeleted == false)) then
			(
				currentBuildingBlock.Name = ui_BB_BName.text + "_" + ( ui_BB_SizeX.value as string) + "x" + ( ui_BB_SizeY.value as string)
			)
		)
		
		on ui_BB_ClearBlock pressed do
		(
			if ((currentBuildingBlock != undefined) and (currentBuildingBlock.isDeleted == false)) then delete currentBuildingBlock
		)
	
		on ui_BB_SaveBlock pressed do
		(
			if ((currentBuildingBlock != undefined) and (currentBuildingBlock.isDeleted == false)) then
			(
				saveName = (libraryPath + currentBuildingBlock.name + ".max")
				isThere = getFiles saveName
				saveObj = copy currentBuildingBlock
				saveObj.name = currentBuildingBlock.name
				lg_ResetXForm saveObj
				if isThere.count == 0 then saveNodes saveObj saveName
				else
				(
					ask = queryBox "This Block already exists.. Overwrite?"
					if ask == true then saveNodes saveObj saveName
				)
				delete saveObj
				refreshBBList2()
				ro_legolizer_Build.refreshBBList()
			)
			else messageBox "There is no buildingBlock to save.." title:"Error!"
		)
	
	)
	
	rollout ro_Legolizer_About "About"
	(
		label lbl_About_01 "Legolizer v0.8" pos:[45,10]
		label lbl_About_02 "(c) 2004 by Andr Hotz" pos:[25,30]
		label lbl_About_03 "Piranha-Bytes, Pluto 13 GmbH" pos:[10,50]
		label lbl_About_04 "Use at your own risk!" pos:[35,80]
		hyperlink ui_AboutLabel1 "> Our Games" address:"http://www.gothic2.com" pos:[15,110] 
		hyperlink ui_AboutLabel2 "> Our Scripts" address:"http://mitglied.lycos.de/bogi1976/" pos:[85,110] 
		hyperlink ui_AboutLabel3 "andre@piranha-bytes.com" pos:[20,130] address:"mailto:andre@piranha-bytes.com"
	)

	rollout ro_Legolizer_Scan "Scan Object"
	(
		groupBox grp_Scan "Scan Options:" pos:[5,5] width:150 height:85
			
		spinner ui_NumX "Block Size: " pos:[15,30] fieldwidth:50 range:[0.01,1000,5] scale:0.01 type:#float
		spinner ui_BlocksPerSeg "Blocks/Segment: " pos:[15,50] fieldwidth:30 range:[1,64,5] scale:1 type:#integer
		
		spinner ui_Subdiv "Mesh Subdivisions: " pos:[15,70] fieldwidth:25 range:[0,16,0] scale:1 type:#integer

--		radioButtons ui_Mirror "Object Symmetry:" pos:[15,140] labels:#( "X", "Y", "Z", "None") columns:3 default:4 enabled:false
		
		button ui_ScanObject "Scan" pos:[5,100] width:75 height:20 tooltip:"Scan Object"
		button ui_LoadBList "Load" pos:[85,100] width:35 height:20  tooltip:"Load Blocklist" enabled:false
 		button ui_SaveBList "Save" pos:[120,100] width:35 height:20 tooltip:"Save Blocklist" enabled:false
		label lbl_ScanInfo "Object not scanned!" pos:[5,130]


		on ui_LoadBList pressed do
		(
			if legoObj != undefined then
			(
				loadBlock = getOpenFileName caption:"Load BlockList"
				if loadBlock != undefined do
				(
					loadFile = openFile loadBlock mode:"r+"
					if loadFile != undefined do
					(
						ident = (readValue loadFile) as String
						if ident == "Legolizer Blocklist" do
						(
							numSeg = readValue loadFile
							numBlocks = readValue loadFile
							legoObj.numSegments = numSeg
							legoObj.numBlocks = numBlocks
							
							bcount = readValue loadFile
							blockSetList = #()
							
							for b = 1 to bCount do
							(
								bpos = readValue loadFile
								append blockSetList bpos
							)
							ui_SegX.value = numSeg.x
							ui_SegY.value = numSeg.y
							ui_SegZ.value = numSeg.z
							ui_NumX.value = numBlocks.x
							ui_NumY.value = numBlocks.y
							ui_NumZ.value = numBlocks.z
							segs = createSegments LegoObj
							legoObj.segList = segs
							legoObj.blockList = blockSetList
							
							lbl_ScanInfo.caption = ((blockSetList.count as string) + " Blocks found!") 
							lbl_ScanInfo.pos = [5,130]

							messageBox ((blockSetList.count as string) + " Blocks loaded!") title:"Info:"
						)
					)
				)
			)
			else messageBox "Select Object first!"
		)
		
		on ui_SaveBList pressed do
		(
			if legoObj != undefined do
			(
				if legoObj.blockList.count > 0 then
				(
					saveBlock = getSaveFileName caption:"Save BlockList"
					if saveBlock != undefined do
					(
						blockFile = openFile saveBLock mode:"w+"
						if blockFile != undefined do
						(
							print "Legolizer Blocklist" to:blockFile
							print [ui_SegX.value, ui_SegY.value, ui_SegZ.value] to:blockFile
							print [ui_NumX.value, ui_NumY.value, ui_NumZ.value] to:blockFile
	
							print legoObj.blockList.count to:blockFile
							for b=1 to legoObj.blockList.count do print legoObj.blockList[b] to:blockFile
							
							close blockFile
						)
					)	
				)
				else messageBox "Scan Object first!!"
			)
		)
		

		function updateBlocks =
		(
			if legoObj != undefined do legoObj.bps = ui_BlocksPerSeg.value as integer
		
			dbox = box pos:legoObj.legoSnap.min
			dBox.wirecolor = blue
			dBox.length = ui_NumX.value
			dBox.height = ui_NumX.value
			dBox.width = ui_NumX.value
			
			forcecompleteRedraw()
			delete dBox
		
		)


		on ui_NumX changed val do updateBlocks()
	
		on ui_Mirror changed state do
		(
			if legoObj != undefined then 
			(
				legoObj.mirror = state
				segs = createSegments legoObj
				legoObj.segList = segs
			)
		)
		
		on ui_ScanObject pressed do
		(
			if legoObj != undefined  then
			(
				with undo off
				(
					startTime = timeStamp()
					user_abort = false
			
					setWaitCursor()

					lbl_ScanInfo.caption = "Preparing Object..."
					lbl_ScanInfo.pos = [5,130]
					-- legoObj.legosnap.isHidden = true
					cui.ExpertmodeOn()
					disableSceneRedraw()
						
					max modify mode
					
					--- prepare sourceObject (snapshot, resetXForm
										
					baseSnap = snapshot legoObj.legoSnap
					convertToMesh baseSnap
					baseSnap.name = uniqueName "!LegoSnapMesh"
					baseSnap.pivot = baseSnap.min
					lg_resetXForm baseSnap
					
				    baseSnap.ishidden = true
					select baseSnap
					
					faceCount = baseSnap.faces.count
					
					fIDList = #()
					for f=1 to faceCount do
					(
						fID = getFaceMatID baseSnap f
						if (findItem fIDList fID) == 0 then append fIDList fID
					)
					
					legoObj.NumMats = fIDList.count
					legoObj.matIDList = fIDList
					legoObj.blockList = #()
					legoObj.buildingArray = #()
					legoObj.maxBlocks = #()
					
					for fi = 1 to fIDList.count do
					(
						append legoObj.blockList #()
						append legoObj.buildingArray #()
						append legoObj.maxBlocks #()
					)
					
					
					bbSize = [ui_NumX.value, ui_NumX.value, ui_NumX.value]
					legoObj.BlockSize = bbSize.x
					
					bps = ui_BlocksPerSeg.value as integer
					blocksize = bbsize
					segSize = bps * bbSize
				
						segVBlock = box length:segSize.y width:segSize.x height:segSize.z
						segVBlock.pivot = segVBlock.center
						segVBlock.ishidden = true
						segVBlock.scale = [1.1, 1.1, 1.1]
						segVBlock.name = uniqueName "!LegoHelperSegBlock"	
						lg_resetXForm segVBlock
						
						volBlock = box length:bbSize.y width:bbSize.x height:bbSize.z
						volBlock.pivot = volBlock.center
						volBlock.ishidden = true
						volBlock.scale = [1.1, 1.1, 1.1]
						volBlock.name = uniqueName "!LegoHelperVolumeBlock"	
						lg_resetXForm volBlock
					
						numCreated = 0

						snapMesh = baseSnap					
						snapMEsh.pos = baseSnap.pos
						snapMesh.name = uniqueName "!LegoHelperMaterialSnapMesh"
						snapMesh.pivot = snapMesh.min
						lg_resetXForm snapMesh
					    snapMesh.ishidden = true
						select SnapMesh


						sMin = snapMesh.min
						orgSMin = snapMesh.min
						sMax = snapMesh.max
						sSize =  (sMax - sMin)
						
						num = sSize / bbsize
						num = [num.x as integer + 1, num.y as integer + 1, num.z as integer + 1] --- total blocks
						numBLocks = num
						
						numSegs = [ (((num.x as integer) / bps ) + 1), (((num.y as integer) / bps ) + 1), (((num.z as integer) / bps ) + 1)]
						
						numblocks = [bps ,bps ,bps ]	
						totalSize = numSegs * segsize
						
						--- size helper box
						
						k = box length:totalsize.y width:totalsize.x height:totalsize.z				
						k.pivot = k.center
						k.pos = snapmesh.center
						
						smin = k.min
						smax = k.max
						sSize = k.max - k.min
						
						delete k 
						
						--- create segs
						
						convertToPoly snapMesh
						flist = #{1..snapmesh.faces.count}
						for sz=0 to (numSegs.z + 1) do    -- x x
						(
							sliceOffset = ((sz-1) * segSize.z) + (segSize.z / 2.0)
							snapMesh.slice [0,0,1] [0,0,sliceOffset]
						)
						for sx=0 to (numSegs.x + 1) do   -- y z
						(
							sliceOffset = ((sx-1) * segSize.x) + (segSize.x / 2.0)
							snapMesh.slice [1,0,0] [sliceOffset,0,0]
						)
						for sy=0 to (numSegs.y + 1) do    -- z y
						(
							sliceOffset = ((sy-1) * segSize.y) + (segSize.y / 2.0)
							snapMesh.slice [0,1,0] [0,sliceOffset,0]
						)
						
						--- create Volume Segment
						

						convertToMesh snapMesh
						snapBase = modpanel.getCurrentObject()
						
						SegVol = Vol__Select()
						addModifier snapmesh SegVol
						
						SegVol.level = 2
						SegVol.type = 0
						SegVol.volume = 3
						SegVol.method = 0
						SegVol.Node = segVBlock
			
						--- create Volume Block
						
				
						numSubs = ui_subDiv.value			
						
						totalBlocks = (numSegs * numBlocks)
			format "Blocks/Seg: %\n" NumBlocks
	
			format "Total Blocks: %\n" totalBLocks
						
						legoObj.maxBlocks = totalBlocks
						
						blocksetList = #(#())
						for fi = 1 to legoObj.NumMats do
						(
							blockSetList[fIDList[fi]] = #()
							blockSetList[fIDList[fi]].count = totalBlocks.x * totalBlocks.y * totalBlocks.z
						)	
			format "Total Count: %\n" blocksetList.count
				
						buildingArray = #(#(#(#(#()))))
						
						for fi = 1 to legoObj.NumMats do
						(
							buildingArray[fIDList[fi]] = #()
							for x=1 to totalBLocks.x do
							(
								buildingArray[fIDList[fi]][x] = #()
								for y=1 to totalBLocks.y do
								(
									buildingArray[fIDList[fi]][x][y] = #()
									for z=1 to totalBlocks.z do
									(
										buildingArray[fIDList[fi]][x][y][z] = #()
									)
								)
							)
						)
						
						faceEM = Mesh_Select()					
						
						format "NumSegs: %\n" (numSegs.X * numsegs.Z * numSegs.Y)
						
						select snapmesh
						
						--addModifier snapMesh faceEM
						
						--- scan through segments:
						
						for zz=1 to NumSegs.z do
						(
							for yy=1 to NumSegs.x do
							(
								for xx=1 to NumSegs.y do
								(
									
									segVBlock.pos = sMin + [((yy-1) * segsize.x) + (segsize.x / 2), ((xx-1) * segsize.y) + (segsize.y / 2), ((zz-1) * segsize.z) + (segsize.z / 2)]
									segFaces = (getFaceSelection snapMesh) as array
									if segFaces.count > 0 do
									(
										segVBlock.scale = [1,1,1]
										oMin = segVBLock.min
										segVBlock.scale = [1.1, 1.1, 1.1]

										modPanel.setCurrentObject snapBase
										triM = meshop.detachFaces snapmesh (segFaces as bitarray) delete:false asMesh:true
										boolBlock = Editable_mesh()
										boolBlock.mesh = triM
										update boolBlock
										newShell2 = shell()
										newShell2.innerAmount = 1
										newShell2.outerAmount = 0
										addmodifier boolblock newShell2

										boolBLock.pos = OrgSmin
										boolBLock.name = uniqueName "!LegoHelperBoolBlock_"
										convertToPoly boolBlock
										lg_resetXForm boolBlock
										-- modpanel.setCurrentObject segVol
	
										if keyboard.escPressed then user_abort = true
										if user_abort then exit
										
										if ((boolBlock.verts.count > 0)) do	--- are there any verts in this segment?
										(
											--- add segments:
											boolBlock.pivot = omin
											lg_ResetXForm boolBlock
		
											
											for sz=0 to (numBlocks.z + 1) do    -- x x
											(
												sliceOffset = ((sz-1) * blockSize.z) + (blocksize.z / 2.0)
												boolBlock.slice [0,0,1] [0,0,sliceOffset]
											)
											for sx=0 to (numBlocks.x + 1) do   -- y z
											(
												sliceOffset = ((sx-1) * blockSize.x) + (blocksize.x / 2.0)
												boolBlock.slice [1,0,0] [sliceOffset,0,0 ]
											)
											for sy=0 to (numBlocks.y + 1) do    -- z y
											(
												sliceOffset = ((sy-1) * blockSize.y) + (blocksize.y / 2.0)
												boolBlock.slice [0,1,0] [0,sliceOffset,0] 		
											)
	
													--- subdivide ?
											if numSubs  >= 1 do
											(
												select boolBlock
												subD = Subdivide()
												subD.manualUpdate = 1
												subd.size = (legoObj.Blocksize / (100.0 * numSubs))
												addModifier boolBlock subD
												collapseStack boolBlock
											)
	
											convertToMesh boolBLock
											
											VolSel = Vol__Select()
											addModifier boolBlock VolSel
											
											volSel.level = 1
											volSel.type = 0
											volSel.volume = 3
											volSel.Node = volBlock
											
											if keyboard.escPressed then user_abort = true
											if user_abort then exit
											
											--- scan through blocks of segment:
											
											for z=1 to (numBlocks.z) do
											(
												for y=1 to (numBlocks.x) do
												(	
													for x=1 to (numBlocks.y) do
													(
														bPos =  oMin + [((y-1) * blocksize.x) + (blocksize.x / 2.0), ((x-1) * blocksize.y) + (blocksize.y / 2.0), ((z-1) * blocksize.z) + (blocksize.z / 2.0)]
						
														volBlock.pos = bpos 					
														volVerts = (getVertSelection boolBlock) as array
						
														if volVerts.count > 0 do
														(	
															matFaces = (meshop.GetFacesUsingVert boolBlock volVerts) as array
															idList = #()
															for m=1 to matFaces.count do
															(
																mID = getFaceMatID boolBlock matFaces[m]
																if (findItem idList mID) == 0 then append idList mID
															)
															
															if idList.count != 0 do	
															( --append blockMatList idList[1]
																fi = idList[1]
																currentBlockX = ((xx - 1) * bps ) + x 
																currentBlockY = ((yy - 1) * bps ) + y 
																currentBlockZ = ((zz - 1) * bps ) + z
																
																seg = xx + ((yy-1) * numSegs.y) + ((zz-1) * numSegs.x * numSegs.y) - 1
																segBlock = seg * bps * bps * bps 
																													
																cb = x + ((y-1) * bps ) + ((z-1) * bps * bps )
																cb = cb + segBlock
															
																blockSetList[fi][cb] = bpos	
																buildingArray[fi][currentBlockY][currentBlockx][currentBlockZ] = bpos
																numCreated += 1
															)
														)
													)
												)
											)						
											
											delete boolblock
											delete $'!LegoHelperBoolBlock_*'
											
											lbl_ScanInfo.caption = "Scanning: " + (numCreated as string) + " Blocks found!"
											lbl_ScanInfo.pos = [5,130]
		
											gc()
										) 
									)
								)
							)
						)
						
					--	delete snapMesh
						delete $'!LegoHelper*'
						max select none
						
						lbl_ScanInfo.caption = (numCreated as string) + " Blocks found!"
						lbl_ScanInfo.pos = [5,130]
						
						legoObj.blockList = blockSetList
						legoObj.buildingArray = buildingArray
						gc()
					   --- end material loop
					
					--delete baseSnap
					setArrowCursor()
					cui.ExpertmodeOff()
	
					enableSceneRedraw()
					forceCompleteRedraw()
					endTime = timeStamp()
					dur = (endTime / 1000.0) - (startTime / 1000.0)
					messageBox ("Object Scanned!\n" + (numCreated as string) + " Blocks found in " + ((dur / 60.0) as string) + " minutes (" + ((dur) as string) + " seconds)") title:"Info:"
					gc()

				)
			)
			else messageBox "Select an Object first!!!" title:"Error!"
		)
	)
	
	rollout ro_Legolizer_Build "Build Block Object"
	(
		listbox ui_BuildingBlockList "Block Library:" pos:[5,5] width:95 height:6 items:#()
		listbox ui_PrioList "Used Blocks:" pos:[5,115] width:95 height:6 items:#()

		button ui_CreateBlock "Create" pos:[105,21] width:50 height:20 tooltip:"Create / Edit Building Block"
		button ui_DeleteBlock "Delete" pos:[105,41] width:50 height:20 tooltip:"Delete Selected Building Block"
		button ui_AddAllBlocks "Add all" pos:[105,66] width:50 height:20 tooltip:"Add all Building Blocks to the Used List"

		button ui_PrioUp "Up" pos:[105,131] width:50 height:20 tooltip:"Move Building Block Priority Up"
		button ui_PrioDown "Down" pos:[105,151] width:50 height:20 tooltip:"Move Building Block Priority Down"
		button ui_ClearPrio "Clear" pos:[105,171] width:50 height:20 tooltip:"Clear List"
		
		checkbutton ui_RandomPrio "Random" pos:[105,196] width:50 height:20 tooltip:"Use Random Order for Building"
	
		radioButtons ui_BuildAxis "Building Axis:" pos:[95,225] labels:#("X", "Y") columns:1
		radioButtons ui_CreationMethod "Creation Method:" pos:[5,225] labels:#("PArray", "Individuals") columns:1
		radioButtons ui_ColorMode "Color Mode:" pos:[5,280] labels:#("Material", "Solid") columns:2
		
		button ui_BuildBlocks "Build Blocks" pos:[5,320] width:80 height:20  tooltip:"Build Block Object"
		button ui_DelBlocks "Delete" pos:[85,320] width:70 height:20 tooltip:"Delete Blocks"

		spinner ui_BlockPercent "View Percent: " pos:[5,345] fieldwidth:40 range:[1,100,100] scale:1 type:#integer enabled:false

		--	radioButtons ui_BlockDisplay  pos:[10,405] labels:#("Mesh", "BBox", "Dots") columns:3 default:1 enabled:false
	
		function refreshBBList =
		(
			bbs = getFiles (libraryPath + "*.max")
			bbnames = #()
			for b=1 to bbs.count do
			(
				n = getFilenamefile bbs[b]
				append bbnames n
			)
			sort bbnames
			ui_BuildingBLockList.items = bbnames
		)
	
		on ro_Legolizer_Build open do
		(
			reFreshBBList()
		)
	
		on ui_DeleteBlock pressed do
		(
			ask = queryBox "Really delete this Building Block?"
			if ask == true do
			(
				name = ui_BuildingBlockList.selected + ".max"
				deleteFile (libraryPath + name)
				refreshBBList()
			)
		)
		
		on ui_CreateBlock pressed do
		(
			if (ro_Legolizer_BlockBuilder.open == false) do createDialog ro_Legolizer_BlockBuilder width:250
		)
		
		on ui_BuildingBlockList doubleClicked val do
		(
			if legoObj != undefined do
			(
				name = ui_BuildingBlockList.selected
				if (findItem legoObj.prioList name) == 0 do
				(
					append legoObj.prioList name
					ui_PrioList.items = legoObj.prioList
				)
			)
		)
		
		on ui_AddAllBlocks pressed do
		(
			if legoObj != undefined do
			(
				newList = ui_BuildingBlockList.items
				legoObj.prioList = newList
				ui_PrioList.items = legoObj.prioList
			)
		)

		on ui_PrioList doubleClicked val do
		(
			if legoObj != undefined do
			(
				deleteItem legoObj.prioList val
				ui_PrioList.items = legoObj.prioList
			)
		)
		
		on ui_PrioUp pressed do
		(
			if legoObj != undefined do
			(
				pList = legoObj.prioList
				selPri = ui_PrioList.selection
				if selPri > 1 do
				(
					swap pList[selPri] pList[selPri - 1]
					legoObj.prioList = pList
					ui_PrioList.items = pList
					ui_PrioList.selection = selPri - 1
				)
			)
		)
		on ui_PrioDown pressed do
		(
			if legoObj != undefined do
			(
				pList = legoObj.prioList
				selPri = ui_PrioList.selection
				if selPri < pList.count do
				(
					swap pList[selPri] pList[selPri + 1]
					legoObj.prioList = pList
					ui_PrioList.items = pList
					ui_PrioList.selection = selPri + 1
				)
			)
		)

		on ui_ClearPrio pressed do
		(
			if legoObj != undefined do
			(
				legoObj.prioList = #()
				ui_PrioList.items = #()
			)
		)
		
		function delBlocks =
		(
			if (lastLego != undefined) do
			(
				for lal = 1 to lastLego.count do
				(
					if ((lastLego[lal] != undefined) and (lastLego[lal].isdeleted == false)) then delete lastLego[lal]
				)
			)
			if (distObj != undefined) do
			(
				for lal = 1 to distObj.count do
				(
					if ((distObj[lal] != undefined) and (distObj[lal].isdeleted == false)) then delete distObj[lal]
				)
			)
			if ((legoObj != undefined) and (legoObj.building_blocks.count != 0)) do
			(
				for bb=1 to legoObj.building_blocks.count do
				(
					if legoObj.building_blocks[bb].obj.isDeleted == false then delete legoObj.building_blocks[bb].obj
				)
				legoObj.building_blocks = #()
			)
			if ((legoObj != undefined) and (legoObj.baseBLockList.count != 0)) do
			(
				for bb=1 to legoObj.baseBLockList.count do
				(
					if legoObj.baseBLockList[bb].isDeleted == false then delete legoObj.baseBLockList[bb]
				)
				legoObj.baseBLockList = #()
			)

			if ((legoObj != undefined) and (legoObj.legoSnap != undefined) and (legoObj.LegoSnap.isDeleted == false)) then unhide legoObj.legoSnap
			distObj = undefined
			lastLego = undefined
			gc()
		)
		
		on ui_DelBlocks pressed do delBlocks()
		
		on ui_BlockDisplay changed state do
		(
			if ((lastLego != undefined) and (lastLego.isDeleted == false)) do
			(
				vt = ui_BlockDisplay.state
				cvt = 2
				if vt == 1 then cvt = 2
				if vt == 2 then cvt = 3
				if vt == 3 then cvt = 0
				lastLego.viewType = cvt
			)
		)
		
		on ui_BlockPercent changed val do
		(
			if ((lastLego != undefined) and (lastLego.isDeleted == false)) do
			(
				lastLego.viewPercent = val
			)
		)

		
		on ui_BuildBlocks pressed do
		(
			if legoObj != undefined  then
			(
				if legoObj.prioList.count > 0 then
				(
					with undo off
					(
						if legoObj.blockList.count > 0 then
						(
							if ((lastLego != undefined)) then
							(
								ask = queryBox "Delete Last Block?" title:"Delete"
								if ask == true then delBlocks()
							)
						
							sMin = legoObj.legoSnap.min
							sMax = legoObj.legoSnap.max
							sSize = sMax - sMin
											
							--- misc setup
							
							cMethod = ui_CreationMethod.state
							cMode = ui_ColorMode.state
							bAxis = ui_BuildAxis.state
							
							if cMode == 1 do
							(
								if legoObj.baseObject.material != undefined then 
								(
									legoMaterial = copy legoObj.baseObject.material
									legoMaterial.name = "Lego Material"
								)
								else 
								(
									legoMaterial = standardMaterial()
									legoMaterial.name = "Lego Material"				
								)
							)
							if cMode == 2 do
							(
								legoMaterial = standardMaterial()
								legoMaterial.name = "Lego Material"										
							)
		
							
							blockSize  = [legoObj.Blocksize, legoObj.Blocksize, legoObj.Blocksize] -- [ro_Legolizer_Scan.ui_NumX.value, ro_Legolizer_Scan.ui_NumX.value, ro_Legolizer_Scan.ui_NumX.value]				
							
							bbfList = legoObj.prioList
							bblocks = #()
							
							for nb = 1 to bbfList.count do
							(
								mergeMaxFile (libraryPath + bbfList[nb] + ".max") #select #mergeDups
								bbo = (getCurrentSelection())[1]
								bbo.scale = blocksize
								lg_resetXForm bbo
								bbo.parent = legoObj.root
								bbo.name = bbfList[nb]
								names = filterString bbfList[nb] "_"
								dim = filterString names[2] "x"
								newBB = buildingBlock()
								newBB.obj = bbo
								newBB.x = dim[2] as integer
								newBB.y = dim[1] as integer
								append bblocks newBB
							)
							
							legoObj.building_Blocks = bblocks
							
							lastLego = #()
							distObj = #()
							baseBLocks = #()
							
							
							for fii=1 to legoObj.numMats do
							(
							
								fi = legoObj.matIDList[fii]
								
								bCount = legoObj.blockList[fi].count
								
								numx = legoObj.MaxBlocks.x
								numy = legoObj.MaxBlocks.y
								numZ = legoObj.MaxBlocks.z
								bPosList = #(#(), #())
		
								ba = legoObj.buildingArray[fi]
								
								numBA = bblocks.count
								
								BAPrioList = #()
								for bpl = 1 to numBa do append BAPrioList bpl
								randomPrio = ui_RandomPrio.state
								
								x=1
								y=1
								z=1
								
								bbPosList = #()
								for b=1 to numBA do
								(
									append bbPosList #()
								)
								
		---- Create Distribution Objects
							
								if bAxis == 1 do
								(						
									while z <= numZ do
									(
										while y <= numY do
										(
										
													
											while x <= numX do
											(
												nx = 1
													if randomPrio == true do
													(
														BAPrioList = #()
														seed (timeStamp() / x)
														for r=1 to numBA do
														(
															newNum = false
															rVal = 1
															
															while newNum == false do
															(
																rval = random 1 numBA
																if (findItem BAPrioList rVal) == 0 do
																(
																	newNum = true
																	
																)
															)
															BAPrioList[r] = rval
														)
													)
												foundBlock = false
												if ((classof ba[x][y][z]) == Point3) do
												(
												
													bb = 1
													while bb <= numBA do
													(
														theBB = bblocks[BAPrioList[bb]]
														curBB = BAPrioList[bb]
														nx = theBB.x
														
														if nx <= (numX - x - 1) do
														(
															fl = #()
															
															for cx = (nx-1) to 0 by -1 do
															(
																if (classof ba[x+cx][y][z]) == point3 then append fl "1"
															)
															if fl.count == nx then
															(
																append bbPosList[curBB] ba[x][y][z]
																foundBlock = true
																bb = numBA
															)
														)
														bb += 1
													)		
												)
												x += nx
											)
											x = 1
											y += 1
										)
										y = 1
										x = 1
										z += 1
									)
								)
								
								if bAxis == 2 do
								(				
									for rotB = 1 to bBlocks.count do
									(
										bBlocks[rotB].obj.rotation.controller.z_rotation = 90
										lg_resetXForm bBlocks[rotB].obj
									)
				
									while z <= numZ do
									(
										while x <= numX do
										(
											while y <= numY do
											(
												nx = 1
												foundBlock = false
												if ((classof ba[x][y][z]) == Point3) do
												(
													if randomPrio == true do
													(
														BAPrioList = #()
														for r=1 to numBA do
														(
															newNum = false
															rVal = 1
															while newNum == false do
															(
																rval = random 1 numBA
																if (findItem BAPrioList rVal) == 0 do
																(
																	newNum = true
																	
																)
															)
															BAPrioList[r] = rval
														)
													)
													bb = 1
													while bb <= numBA do
													(
														theBB = bblocks[BAPrioList[bb]]
														curBB = BAPrioList[bb]
														nx = theBB.x
														
														if nx <= (numY - y - 1) do
														(
															fl = #()
															
															for cx = (nx-1) to 0 by -1 do
															(
																if (classof ba[x][y+cx][z]) == point3 then append fl "1"
															)
															if fl.count == nx then
															(
																append bbPosList[curBB] ba[x][y][z]
																foundBlock = true
																bb = numBA
															)
														)
														bb += 1
													)		
												)
												y += nx
											)
											y = 1
											x += 1
										)
										y = 1
										x = 1
										z += 1
									)
								)
		
		------- Build Blocks
								for b=1 to numBA do
								(
									bblocks[b].bCount = bbPosList[b].count
									if bblocks[b].bCount > 0 then
									(
										bCount = bblocks[b].bCount
										newDistObj = mesh numVerts:bcount
										for v = 1 to bCount do setVert newDistObj v bbPosList[b][v]
										newdistObj.name = uniqueName (legoObj.baseObject.name + "_DistributionObject_" + (b as string))
										newdistObj.renderable = false
										newDistObj.parent = legoObj.root
										newdistObj.boxmode = true
										bblocks[b].bDistObj = newDistObj
		----- create ParticleArray:								
										if cMethod == 1 do		
										(								
											cloud = pArray()
											cloud.emitter = bblocks[b].bDistObj
											cloud.formation = 2				
											cloud.viewType = 2
											cloud.viewPercent = ui_BlockPercent.value
											cloud.quantityMethod = 1
											cloud.total_number = bblocks[b].bCount
											cloud.Speed = 0
											cloud.life = 100
											cloud.Divergence_Angle = 0
											cloud.Emitter_Start = 0f
											cloud.Emitter_Stop = 0f
											cloud.Growth_Time = 0f
											cloud.Fade_Time = 0f
											cloud.particleType = 3
											cloud.materialSource = 2
											
											instObj = copy bblocks[b].obj
											instObj.name = uniqueName (legoObj.baseObject.name + "_MatBuildingBlock_" + (b as string))
											if cMode == 1 then newMatID = fi
											if cMode == 2 then newMatID = 1
											
											for fa = 1 to instObj.faces.count do setFaceMatID instObj fa newMatID
											instObj.material = legoMaterial
											append baseBlocks instObj
											
											cloud.instancingObject = instObj 
											cloud.name = uniqueName (legoObj.baseObject.name + "_ParticleBlock_" + (b as string))
											cloud.materialSource = 2
											cloud.pos = cloud.center
											cloud.material = legoMaterial
											bblocks[b].bMeshObj = cloud								
										)
		----- create Individuals:								
										if cMethod == 2 do		
										(								
											instObj = copy bblocks[b].obj
											instObj.name = uniqueName (legoObj.baseObject.name + "_MatBuildingBlock_" + (b as string))
											if cMode == 1 then newMatID = fi
											if cMode == 2 then newMatID = 1
											
											for fa = 1 to instObj.faces.count do setFaceMatID instObj fa newMatID
											instObj.material = legoMaterial
											append baseBlocks instObj

											dObj = bBlocks[b].bDistObj
											
											newBLockArray = #()
											for p=1 to dObj.verts.count do
											(
												pointPos = getVert dObj p
												newBlockObject = instance instObj
												newBlockObject.pos = pointPos
												newBlockObject.name = uniqueName (legoObj.baseObject.name + "_Block_" + (b as string) + "_" + (p as string))
												append newBlockArray newBlockObject
											)				
											cloud = group newBlockArray prefix:(legoObj.baseObject.name + "_BlockGroup_" + (b as string))
		
											bblocks[b].bMeshObj = cloud								
										)
		
										cloud.parent = legoObj.root
										append lastLego cloud
										append distObj newDistObj
									)
								)
							)
							
							hide legoObj.legoSnap
							legoObj.baseBLockList = baseBlocks
							forceCompleteRedraw()
							gc()
						)
						else messageBox "Scan object first!" title:"Error!"
					)
				)
				else MessageBox "No Building Blocks selected!" title:"Error!"
			)
			else messageBox "Select object first!" title:"Error!"
		)
	)

	rollout ro_Legolizer_Main "Source Object"
	(
		pickButton ui_SelectObj "Select Source Object" pos:[5,5] width:150 height:20 tooltip:"Select Object to Legolize"
		groupBox grp_BSet "Basic Settings:" pos:[5,30] width:150 height:90
		label lbl_OOffset "Object Offset (XYZ):" pos:[15,50]
		spinner ui_XOff pos:[12,70] fieldwidth:30  range:[-99999,99999,0] scale:0.1 type:#float
		spinner ui_YOff pos:[57,70] fieldwidth:30  range:[-99999,99999,0] scale:0.1 type:#float
		spinner ui_ZOff pos:[102,70] fieldwidth:30 range:[-99999,99999,0] scale:0.1 type:#float
		spinner ui_Reduce "Reduce mesh to " pos:[13,95] fieldwidth:30 range:[1,100,100] scale:1 type:#integer
		label lbl_redText "%" pos:[140,95]
		
		
		on ro_Legolizer_Main open do
		(
			sPath = getDir #scripts
			makedir (spath + "\\PB_Data")
			makedir (sPath + "\\PB_Data\\Legolizer")
			legoPath = (sPath + "\\PB_Data\\Legolizer\\")
			makedir (legoPath + "Block_Library")
			makedir (legoPath + "Config")
			libraryPath = legoPath + "Block_Library\\"		
		)
		
		on ui_XOff changed val do
		(
			if legoObj != undefined do
			(
				legoObj.legoOffset = [ui_xOff.value, ui_yOff.value, ui_zOff.value]
				legoObj.root.pos = legoObj.legoOffset
			)
		)
		on ui_YOff changed val do
		(
			if legoObj != undefined do
			(
				legoObj.legoOffset = [ui_xOff.value, ui_yOff.value, ui_zOff.value]
				legoObj.root.pos = legoObj.legoOffset
			)
		)
		on ui_ZOff changed val do
		(
			if legoObj != undefined do
			(
				legoObj.legoOffset = [ui_xOff.value, ui_yOff.value, ui_zOff.value]
				legoObj.root.pos = legoObj.legoOffset
			)
		)
		
		on ui_Reduce changed val do
		(
			if legoObj != undefined do
			(
				select legoObj.legoSnap
				max modify mode
				legoObj.mres.vertexPercent = val
			)
		)
		
		on ui_SelectObj picked obj do
		(
			if (legoObj != undefined) then deleteLegoObj()

			ui_SelectObj.caption = obj.name
			legoObj = LegoStruct()
			legoObj.baseObject = obj
			
			legoSnap = snapShot obj			
			legoSnap.name = Obj.name + "_BaseSnapshot"
			lg_resetXForm legoSnap
			
			snapSize = legoSnap.max - legoSnap.min
			legoOffset = [(snapSize.x * 1.5), 0, 0]
			ui_XOff.value = legoOffset.x
			ui_YOff.value = 0 
			ui_ZOff.value = 0
			
			legoRoot = Dummy pos:[0,0,0]
			legoRoot.name = Obj.name + "_LegoRoot"
			legoSnap.parent = legoRoot
			
			legoRoot.pos = legoOffset
			
			select legoSnap
			max modify mode
			
			legoSnap.material = copy obj.material
			legoSnap.wirecolor = obj.wirecolor
			
			mRes = multiRes()
			addmodifier legoSnap mRes
			mRes.vertexPercent = ui_Reduce.value
			mRes.reqGenerate = true
			
			legoObj.mres = mres
			
			legoObj.legoSnap = legoSnap
			legoObj.root = legoRoot
			legoObj.legoOffset = legoOffset
			
			legoSize = legoSnap.max - legosnap.min
			sizeList = #(legoSize.x, legosize.y, legosize.z)
			bs = amax sizeList
			ro_Legolizer_Scan.ui_NumX.value = bs / 20 
			
			gc()
		)
						
		on ro_Legolizer_Main close do
		(
			deleteLegoObj()
			enableSceneRedraw()
			cui.ExpertmodeOff()
			destroyDialog ro_Legolizer_BlockBuilder
			gc()
		)
	)
	
	legolizer_floater = newRolloutFloater "PB  Legolizer v0.8" 175 400
	addRollout ro_Legolizer_About legolizer_Floater rolledUp:True
	addRollout ro_Legolizer_Main legolizer_Floater rolledUp:false
	addRollout ro_Legolizer_Scan legolizer_Floater rolledUp:True
	addRollout ro_Legolizer_Build legolizer_Floater rolledUp:True
)